package com.flyfish.framework.utils;

import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;

import java.util.Collection;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * 字符串帮助类
 *
 * @author wangyu
 */
public class StringHelper {

    /**
     * 获取对象的值
     *
     * @param obj 对象
     * @return 结果
     */
    public static String getObjectValue(Object obj) {
        return obj == null ? "" : obj.toString();
    }

    /**
     * 快速的join一个集合
     *
     * @param collection 集合
     * @param mapper     映射
     * @param <T>        泛型
     * @return 结果
     */
    public static <T> String join(Collection<T> collection, Function<T, String> mapper) {
        if (CollectionUtils.isNotEmpty(collection)) {
            return collection.stream().map(mapper).filter(StringUtils::isNoneBlank).collect(Collectors.joining(","));
        }
        return "";
    }
}
