package com.flyfish.framework.domain.tree;

import org.springframework.data.util.CastUtils;

import java.util.Collections;

/**
 * 根节点表示
 *
 * @param <T>
 */
public class RootTreeNode<T extends TreeDomain<T>> extends TreeDomain<T> {

    private static final RootTreeNode<?> INSTANCE = new RootTreeNode<>();

    static {
        INSTANCE.setDepth(0);
        INSTANCE.setName("根节点");
        INSTANCE.setParentIds(Collections.emptyList());
        INSTANCE.setId("0");
        INSTANCE.setCode("0");
    }

    public static <T extends TreeDomain<T>> T instance() {
        return CastUtils.cast(INSTANCE);
    }
}
