package com.flyfish.framework.r2dbc.metadata.visitor;

import com.flyfish.framework.r2dbc.metadata.R2dbcTableMetadata;
import org.springframework.data.relational.core.sql.Visitable;
import org.springframework.data.relational.core.sql.Visitor;
import org.springframework.lang.NonNull;

/**
 * 元数据访问者
 *
 * @author wangyu
 */
public interface MetadataVisitor extends Visitor {

    /**
     * 访问元数据的方法
     *
     * @param metadata 元数据
     */
    void enter(R2dbcTableMetadata metadata);

    @Override
    default void enter(@NonNull Visitable segment) {
        if (segment instanceof R2dbcTableMetadata) {
            enter((R2dbcTableMetadata) segment);
        }
    }
}
