package com.flyfish.framework.dict.domain;

import com.flyfish.framework.domain.base.NameLikeQo;
import com.flyfish.framework.query.QueryDefinition;
import lombok.Getter;
import lombok.Setter;
import org.apache.commons.collections4.CollectionUtils;

import java.util.Arrays;
import java.util.List;

/**
 * 字典查询实体
 *
 * @author wangyu
 */
@Getter
@Setter
public class DictionaryQo extends NameLikeQo<Dictionary> {

    // 包含的code
    private List<String> codes;

    @Override
    public QueryDefinition queryBuilder() {
        return super.queryBuilder().mutate().and(Dictionary::getCode).in(codes);
    }

    @Override
    public List<String> getFields() {
        if (CollectionUtils.isNotEmpty(codes)) {
            return Arrays.asList("_id", "code");
        }
        return super.getFields();
    }
}
