package com.flyfish.framework.file.domain;

import com.flyfish.framework.annotations.Property;
import com.flyfish.framework.domain.base.AuditDomain;
import lombok.*;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.relational.core.mapping.Table;

@Document(collection = "attachments")
@Table("t_attachment")
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@Builder
@Property(key = "name", value = "附件名称")
public class Attachment extends AuditDomain {

    /**
     * 大小
     */
    private String size;

    /**
     * 附件路径
     */
    private String path;

    /**
     * 附件Url
     */
    private String url;
}
