package com.flyfish.framework.user.config.audit;

import com.flyfish.framework.auditor.ReactiveBeanPoster;
import com.flyfish.framework.domain.po.Role;
import com.flyfish.framework.user.service.UserDetailsConverter;
import com.flyfish.framework.utils.ReactiveRedisOperations;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;
import reactor.core.publisher.Mono;

/**
 * 角色bean后置处理
 *
 * @author wangyu
 */
@Component
@RequiredArgsConstructor
public class RoleBeanPoster implements ReactiveBeanPoster<Role> {

    private final ReactiveRedisOperations reactiveRedisOperations;
    private final UserDetailsConverter userDetailsConverter;

    /**
     * 对入库的实体进行审查，并执行额外功能
     *
     * @param data 原数据
     */
    @Override
    public Mono<Role> post(Role data) {
        // 更新缓存
        return reactiveRedisOperations.del(reactiveRedisOperations.getKeys("user-*")).thenReturn(data);
    }
}
