package com.flyfish.framework.user.config.properties;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;

/**
 * 安全配置类
 *
 * @author wangyu
 */
@ConfigurationProperties(prefix = "security")
@Data
public class SecurityProperties {

    // 允许的uris
    private String[] allowUris = new String[0];

    // 启用rsa
    private boolean rsa;

    // 验证码配置
    private CaptchaProperties captcha = new CaptchaProperties();

    /**
     * 验证码属性
     * @author wangyu
     */
    @Data
    public static class CaptchaProperties {

        // 启用验证码
        private boolean enable;

        // 顶象appid
        private String appId;

        // 顶象appSecret
        private String appSecret;

        // 服务器地址
        private String server;
    }
}
