package com.flyfish.framework.user.domain;

import com.flyfish.framework.domain.base.NameLikeQo;
import com.flyfish.framework.domain.po.User;
import com.flyfish.framework.query.QueryDefinition;
import lombok.*;

import java.util.List;

@Getter
@Setter
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class UserQo extends NameLikeQo<User> {

    private String type;

    private String username;

    private String password;

    private String phone;

    private String status;

    private List<String> departments;

    @Override
    public QueryDefinition queryBuilder() {
        return super.queryBuilder()
                .mutate()
                .and(User::getType).eq(type)
                .and(User::getUsername).eq(username)
                .and(User::getPassword).eq(password)
                .and(User::getPhone).eq(phone)
                .and(User::getStatus).eq(status)
                .and(User::getDepartments).in(departments);
    }
}
