package com.flyfish.framework.user.initializer;

import org.springframework.beans.factory.InitializingBean;

/**
 * 用户初始化器，可以重写
 */
public interface UserInitializer extends InitializingBean {

    /**
     * 初始化
     */
    void initialize();

    /**
     * 间接初始化
     *
     * @throws Exception 异常
     */
    @Override
    default void afterPropertiesSet() throws Exception {
        initialize();
    }
}
